#!/usr/bin/env ruby
# $Id: imap.rb,v 1.1 2014/04/10 $
###############################################################################
################        Script by Jim Clark - BanditBBS@gmail.com #############
################        http://www.bandits-home-on-the-web.com    #############
################        Based on nagMailAck.rb and imap.rb        #############
###############################################################################
require "net/imap"
#$:.unshift(File.dirname(__FILE__) + '/../lib')
#$:.unshift('/usr/lib/ruby/gems/1.8/gems/rubyntlm-0.4.0/lib')
$:.unshift('/usr/local/rvm/gems/ruby-2.0.0-p247/gems/rubyntlm-0.4.0/lib')
require "net/ntlm"
require 'openssl'
#OpenSSL::SSL::VERIFY_PEER = OpenSSL::SSL::VERIFY_NONE
#Net::IMAP::debug = true
###############################################################################
################        Set variables                             #############
###############################################################################
$host = "xxx.xxx.com" #IMAP Server
$port = 143 #IMAP Port
$ssl = false #Use SSL
$user = "xxxxxxx" #IMAP User
$passwd = "xxxxxxx" #IMAP Password
$nagID = '1' #Server ID for subject
###############################################################################
################        Setup IMAP Connection with NTLM           #############
###############################################################################
module Kernel
  def suppress_warnings
    original_verbosity = $VERBOSE
    $VERBOSE = nil
    result = yield
    $VERBOSE = original_verbosity
    return result
  end
end
module Net
  class IMAP
    class NtlmAuthenticator
      def process(data)
        case @state
        when 1
          @state = 2
          t1 = Net::NTLM::Message::Type1.new()
          return t1.serialize
        when 2
          @state = 3
          t2 = Net::NTLM::Message.parse(data)
          t3 = t2.response({:user => @user, :password => @password}, {:ntlmv2 => (@ntlm_type == "ntlmv2")})
          return t3.serialize
        end
      end

      private

      def initialize(user, password, ntlm_type = "ntlmv2")
        @user = user
        @password = password
        @ntlm_type = @ntlm_type
        @state = 1
      end
    end
    add_authenticator "NTLM", NtlmAuthenticator

    class ResponseParser
      def continue_req
        match(T_PLUS)
        if lookahead.symbol == T_CRLF # means empty message
          return ContinuationRequest.new(ResponseText.new(nil, ""), @str)
        end
        match(T_SPACE)
        return ContinuationRequest.new(resp_text, @str)
      end
    end
  end
end
###############################################################################
################        Check each email for proper subject       #############
###############################################################################
def nagiosACK(eMailSubject,machineString,eMailFrom,eMailHost)
	#Define Variables
    machineID = machineString
    subject = eMailSubject
    fromWho = eMailFrom+"@"+eMailHost
    @commandFile = '/usr/local/nagios/var/rw/nagios.cmd' #Nagios command file location
    @subjectTokens =subject.split(/\s/) #Split the email subject at spaces

    if @subjectTokens[0]!=machineID #Wrong subject for this server
      system('echo "@Error: eMail Subject has Wrong Machine ID" >> /var/log/nagAck.log') #Log wrong subject
      return false
    end #Return to main part of script

    #composing acknowledgement string for nagios.cmd
    if subject.index("Host") != nil
     hostNfo, svcNfo, statNfo = subject.match(/.+ - ([\w\.-]+)\/(\/?.+) is (\w+)/i).captures
      @ackCmd="ACKNOWLEDGE_HOST_PROBLEM;"+hostNfo
      @ackCmd=@ackCmd+";1;1;1;"+fromWho+";acknowledged through nagiosMailACK"
      printMsg = "-acknowledged the Notification of " + @subjectTokens[4] + " about "
      printMsg = printMsg + hostNfo  + "\n"
      printMsg = 'echo "' + printMsg + '" >> /var/log/nagAck.log'
      system(printMsg)
    elsif  subject.index("Service") != nil
     hostNfo, svcNfo, statNfo = subject.match(/.+ - ([\w\.-]+)\/(\/?.+) is (\w+)/i).captures
      @ackCmd = "ACKNOWLEDGE_SVC_PROBLEM;"+hostNfo+";"+svcNfo
      @ackCmd=@ackCmd+";1;1;1;"+fromWho+";acknowledged through nagiosMailACK"
      printMsg = "-acknowledged the Notification of " + @subjectTokens[4] + " in " + svcNfo
      printMsg = printMsg +  " @host: " + hostNfo + "\n"
      printMsg = 'echo "' + printMsg + '" >> /var/log/nagAck.log'
      system(printMsg)
    end
        now= Time.now.strftime("%s")
        runCmd="echo '[%lu] " + @ackCmd + "' " + now + " > " + @commandFile
        result = %x[#{runCmd}]
        system('echo ' + result + '>> /var/log/nagAck.log')
    #system('echo>> /var/log/nagAck.log')
    system('echo>> /var/log/nagAck.log')
    return true
end
###############################################################################
################        Main script section                       #############
###############################################################################
loop do
suppress_warnings {OpenSSL::SSL::VERIFY_PEER = OpenSSL::SSL::VERIFY_NONE}
imap = Net::IMAP.new($host, $port, $ssl) #Create new IMAP connection
imap.authenticate("NTLM", $user, $passwd) #Authenticate to IMAP connection
system('echo "***************logged in ******************" >> /var/log/nagAck.log') #Log successful connection
imap.select("Inbox") #Select the Inbox folder
messages_to_archive = []
@mailbox = "-1"

# retrieve all messages in the INBOX that are not marked as DELETED
imap.search(["NOT", "DELETED"]).each do |message_id|
  @mailbox = imap.fetch(message_id, 'ENVELOPE')[0].attr['ENVELOPE'].to[0].mailbox
  @mailbox = @mailbox.gsub(/([_\-\.])+/, ' ').downcase
  @mailbox.gsub!(/\b([a-z])/) { $1.capitalize }
  envelope = imap.fetch(message_id, "ENVELOPE")[0].attr["ENVELOPE"]
  system("echo 'ackFrom: #{envelope.from[0].mailbox}' >> /var/log/nagAck.log")
  system("echo 'Subject: #{envelope.subject}' >> /var/log/nagAck.log")
  if nagiosACK(envelope.subject,$nagID,envelope.from[0].mailbox,envelope.from[0].host)
    messages_to_archive << message_id
    begin
      #create the mailbox, unless it already exists
      imap.create(@mailbox) unless imap.list('', @mailbox)
      rescue Net::IMAP::NoResponseError => error
    end
    #copy the message to the proper mailbox/label
    imap.copy(message_id, @mailbox)
  end
  system('echo "nagiosACK executed\n=----------=\n" >> /var/log/nagAck.log')
end
imap.store(messages_to_archive, "+FLAGS", [:Deleted]) unless messages_to_archive.empty? # archive the original messages
imap.logout # imap.disconnect
system('echo "*****************logged out**********************" >> /var/log/nagAck.log')
sleep(540) #Time_in_seconds
end